#!/usr/bin/env python
#-------------------------------------------
#
# Copyright (c) 2001 DataChannel, Inc. All Rights Reserved.
#
# LGPL 2.1
#
# $Id:$
#
#-------------------------------------------

import atexit
import random
import sys
import thread

import sample

from omniORB import CORBA

orb = CORBA.ORB_init(sys.argv, CORBA.ORB_ID)

if len(sys.argv) > 1:
    objStr = sys.argv[1]
else:
    objStr = open('SampleServer.ior', 'r').read()

serv = orb.string_to_object(objStr)
serv = serv._narrow(sample.Server)
print "serv=%s" % serv

session = serv.getSession()

def logout_atexit(session):
    try:
        session.logout()
    except: pass
atexit.register(logout_atexit, session)

print "session=%s" % session

def create(count=2, buf=''):
    for x in xrange(count):
        so = session.createStorageObject()
        so.write(0, buf)
        print thread.get_ident(), so

def runSomeTests():
    print "Create a StorageObject named 'foo'"
    foo = session.createStorageObject()
    session.nameStorageObject('foo', foo)
    print foo

    print "Write 'mary had a little lamb' to foo"
    foo.write(0, 'mary had a little lamb')
    print "Content of foo: '%s'" % foo.read(0, 0)

    print "Create a StorageObject named 'bar'"
    bar = session.createStorageObject()
    session.nameStorageObject('bar', bar)
    print bar

    print "Names of all StorageObjects:"
    print map(lambda so: so.getName(), session.getStorageObjects())
