#!/usr/bin/env python
#-------------------------------------------
#
# Copyright (c) 2001 DataChannel, Inc. All Rights Reserved.
#
# LGPL 2.1
#
# $Id:$
#
#-------------------------------------------


import os.path
import sys, os, getopt, string
import re

import ZODB
from ZODB import FileStorage
from ZEO import ClientStorage

from Server import SampleServer

import omniORB
omniORB.traceLevel(1)

import CORBA

def fileStorage():
    print "Using FileStorage"
    return FileStorage.FileStorage('data.fs')

def zeoClientStorage():
    print "Using ZEO ClientStorage"
    _ZEO_ADDRESS = 'localhost'
    _ZEO_PORT = 9672
    return ClientStorage.ClientStorage(
        connection=(_ZEO_ADDRESS, _ZEO_PORT),
        name="ZEO Client",
        var=".")
    
def main(argv):
    if len(sys.argv) > 1 and sys.argv[1] == 'zeo':
        storage = zeoClientStorage()
    else:
        storage = fileStorage()
        
    orb = CORBA.ORB_init(sys.argv, CORBA.ORB_ID)

    serv = SampleServer(storage, "SampleServer")
    servObj = serv._this()

    file = open('SampleServer.ior', 'w')
    ior = orb.object_to_string(servObj)
    file.write(ior)
    file.close()

    print "Started SampleServer %s" % servObj

    orb.run()

if __name__=='__main__':
    main(sys.argv)
