#-------------------------------------------
#
# Copyright (c) 2001 DataChannel, Inc. All Rights Reserved.
#
# LGPL 2.1
#
# $Id:$
#
#-------------------------------------------

import profile
import sys
import thread
import time

class ReturnSafeProfile(profile.Profile):
	def trace_dispatch_return(self, frame, t):
		if self.cur[-1]:
			return profile.Profile.trace_dispatch_return(self, frame, t)
		else:
			self.cur = None
			
	def trace_dispatch_return(self, frame, t):
		rt, rtt, rct, rfn, frame, rcur = self.cur
		rtt = rtt + t
		sft = rtt + rct

		cc, ns, tt, ct, callers = self.timings[rfn]
		if not ns:
			ct = ct + sft
			cc = cc + 1
		self.timings[rfn] = cc, ns - 1, tt+rtt, ct, callers

		if rcur:
			pt, ptt, pct, pfn, pframe, pcur = rcur
			self.cur = pt, ptt+rt, pct+sft, pfn, pframe, pcur
			if callers.has_key(pfn):
				callers[pfn] = callers[pfn] + 1  # hack: gather more
				# stats such as the amount of time added to ct courtesy
				# of this specific call, and the contribution to cc
				# courtesy of this call.
			else:
				callers[pfn] = 1
		else:
			self.cur = None

		return 1

_threadToProfiler = {}
ident = thread.get_ident
time = time.time

def profileThread(cmd='profileThread'):
	tId = ident()
	sys.setprofile(None)
	if _threadToProfiler.has_key(tId):
		oldP = _threadToProfiler[tId]
		oldP.dump_stats('%s-%s-%s.stats' % \
			(oldP.fileName, tId, time()))
	p = ReturnSafeProfile()
	p.fileName = cmd
	_threadToProfiler[tId] = p
	p.set_cmd(cmd)
	p.set_cmd('outerProfiler')
	sys.setprofile(p.dispatcher)

def stopProfiling():
	sys.setprofile(None)

if __name__ == '__main__':
	def foo():
		profileThread()
	foo()
	profileThread()
	def test():
		for x in range(1000):
			5 + 5
	5 + 5
	stopProfiling()
	_threadToProfiler[ident()].print_stats()
